#ifndef DALLASCRC8__HPP
#define DALLASCRC8__HPP

// Standard includes

// Vendor includes

// Project includes


class DallasCrc8
{
public:
    DallasCrc8();
    DallasCrc8( unsigned char crcInitialValue );
    virtual ~DallasCrc8();

    void Restart();
    unsigned char AddByte( unsigned char byte );
    unsigned char AddBuffer( unsigned char* pBuffer, unsigned int length );
    unsigned char Get() const;

protected:

private:
    // Copy constructor is invalid and not defined, declared here to
    // prevent the compiler generating the default definition
    DallasCrc8( const DallasCrc8& rOther );

    // Copy assignment operator is invalid and not defined, declared
    // here to prevent compiler generating the default definition
    DallasCrc8& operator=( const DallasCrc8& rOther );

    static const unsigned char s_CrcTableLow[];
    static const unsigned char s_CrcTableHigh[];
    unsigned char m_Crc;
    unsigned char m_CrcInitialValue;
};


#endif // DALLASCRC8__HPP
