// Standard includes
#include <iostream>

// Vendor includes

// Project includes
#include "LoggerServerImpl.hpp"

// Using declarations


LoggerServerImpl::LoggerServerImpl()
    : m_ExternalLogger( 0 )
{
}

LoggerServerImpl::~LoggerServerImpl()
{
}

void LoggerServerImpl::SetExternalLogger( ExternalLogger externalLogger )
{
    m_ExternalLogger = externalLogger;
}

void LoggerServerImpl::Output( MessageHeader* pMessage )
{
    // Snapshot pointer shall be used
    ExternalLogger externalLogger = m_ExternalLogger;
    if ( 0 != externalLogger )
    {
        const char* pClientName;
        switch ( pMessage->ClientId )
        {
        case LOGGER_CLIENT_ID__READER_FABRIC:
            pClientName = "reader fabric";
            break;

        case LOGGER_CLIENT_ID__READER_PLUG_AND_PLAY:
            pClientName = "reader plug&play";
            break;

        case LOGGER_CLIENT_ID__READER_MODEL_PRP_08:
            pClientName = "reader PRP-08";
            break;

        case LOGGER_CLIENT_ID__READER_MODEL_PR_EH08:
            pClientName = "reader PR-EH08";
            break;

        default:
            pClientName = "unknown";
            break;
        }

        const char* pLevelName;
        switch ( pMessage->Level )
        {
        case LoggerClient::LOGGER_LEVEL__ERROR:
            pLevelName = "error";
            break;

        case LoggerClient::LOGGER_LEVEL__WARNING:
            pLevelName = "warning";
            break;

        case LoggerClient::LOGGER_LEVEL__INFO:
            pLevelName = "info";
            break;

        case LoggerClient::LOGGER_LEVEL__DEBUG:
            pLevelName = "debug";
            break;

        default:
            pLevelName = "unknown";
            break;
        }

        externalLogger( pClientName, pLevelName, STRING( pMessage + 1 ) );
    }
}

void LoggerServerImpl::Flush()
{
    std::cout.flush();
}
