#ifndef LOGGERIMPL__HPP
#define LOGGERIMPL__HPP

// Standard includes

// Vendor includes

// Project includes
#include "Logger.hpp"


class LoggerServerImpl : public LoggerServer
{
public:
    enum LoggerClientId
    {
        LOGGER_CLIENT_ID__READER_FABRIC = 0,
        LOGGER_CLIENT_ID__READER_PLUG_AND_PLAY,
        LOGGER_CLIENT_ID__READER_MODEL_PRP_08,
        LOGGER_CLIENT_ID__READER_MODEL_PR_EH08,
    };

    typedef void ( *ExternalLogger )( const char* pClientName, const char* pLevelName, char* pText );

    LoggerServerImpl();
    virtual ~LoggerServerImpl();

    void SetExternalLogger( ExternalLogger externalLogger );

protected:
    virtual void Output( MessageHeader* pMessage );
    virtual void Flush();

private:
    // Copy constructor is invalid and not defined, declared here to
    // prevent the compiler generating the default definition
    LoggerServerImpl( const LoggerServerImpl& rOther );

    // Copy assignment operator is invalid and not defined, declared
    // here to prevent compiler generating the default definition
    LoggerServerImpl& operator=( const LoggerServerImpl& rOther );

    ExternalLogger m_ExternalLogger;
};


#endif // LOGGERIMPL__HPP
